<template>
  <div>
    <!-- <v-btn class="mt-3" color="success" @click="getData()">Get Data</v-btn> -->
    <v-row>
      <v-col v-for="(item, index) in apidata" :key="index" cols="3">
        <v-card class="ma-4" width="300" height="450">
          <v-img :src="item.dynamicImageUrl"></v-img>
          <v-card-title class="text-h5">{{ item.items }}</v-card-title>
          <v-card-text>
            <div>Price: {{ item.total_price }}</div>
            <div>Quantity: {{ item.amount }}</div>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="info" text @click="editItem(item)">edit</v-btn>
            <v-btn color="error" @click="saveDelete(item._id)">delete</v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
    <v-dialog v-model="dialogedit" max-width="500px">
      <v-card>
        <v-card-title>{{ savemode }}</v-card-title>
        <v-row>
          <v-col cols="6">
            <v-text-field
              v-model="productItem"
              label="items"
              id="items"
              readonly
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="6">
            <v-text-field
              v-model="postOrder.amount"
              @input="editTotalprice()"
              label="amount"
              type="number"
              id="amount"
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="6">
            <v-text-field
              v-model="showPrice"
              label="allPrice"
              type="number"
              id="amount"
              readonly
            ></v-text-field>
          </v-col>
        </v-row>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="error" text @click="closeItem()">cancel</v-btn>
          <v-btn color="info" text @click="saveSelect()">save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
  data() {
    return {
      dynamicImageUrl: "",
      id: "",
      amountEdit: 0,
      dialogedit: false,
      editProduct: 0,
      editPrice: 0,
      allPrice: 0,
      showPrice: 0,
      productItem: 0,
      apidata: [],
      postOrderdefault: {
        items: "",
        amount: "",
        total_price: "",
      },
      postOrder: {
        items: "",
        amount: "",
        total_price: "",
      },
    };
  },
  methods: {
    computed: {
      savemode() {
        return this.id == "" ? "Edit Order" : "Delete Order";
      },
    },
    editTotalprice() {
      this.editPrice =
        (this.allPrice / this.amountEdit) * this.postOrder.amount;
      console.log(
        "this.editPrice:",
        this.amountEdit, //แก้ไขจำนวน
        this.postOrder.amount
      ); //จำนวนปัจจุบัน
      this.showPrice =
        this.editPrice != this.allPrice ? this.editPrice : this.allPrice;
      console.log("editTotalprice: ", this.allPrice);
      console.log("final price: ", this.editPrice);
      this.editProduct = Math.abs(this.amountEdit - this.postOrder.amount);
      console.log("editProduct: ", this.editProduct);
      if (this.amountEdit < this.postOrder.amount) {
        this.devalue = true; //แก้ไขแล้วมากกว่าปัจบันจะบวกเพิ้มใน product
      } else {
        this.devalue = false; //แก้ไขแล้วน้อยกว่าปัจบันจะลดใน product
      }
    },

    editItem(item) {
      this.amountEdit = item.amount;
      console.log("item: ", item.total_price);
      console.log("Amout: ", item.amount);
      this.allPrice = item.total_price;
      console.log("allpice in edit item: ", this.allPrice);
      this.id = item._id;
      this.postOrder = item;
      this.dialogedit = true;
      this.productItem = item.items;
    },

    async getData() {
      try {
        const response = await this.axios.get(
          "http://localhost:3000/listOrder/"
        );
        this.apidata = response.data.data;
        this.getDynamicImage(); // เรียกใช้ getDynamicImage() หลังจากที่ได้รับค่า apidata แล้ว
      } catch (error) {
        console.error("Error fetching data:", error);
      }
    },
    closeItem() {
      this.id = "";
      this.postOrder = { ...this.postOrderdefault };
      this.dialogedit = false;
    },
    saveSelect() {
      if (this.id != "") {
        this.savePutData();
      } else {
        alert("ERROR");
      }
    },
    async savePutData() {
      try {
        console.log("this: ", this.editPrice);
        const { data } = await this.axios.put(
          "http://localhost:3000/listOrder/" + this.id,
          this.postOrder
        );
        alert("Update Data Complete");
        console.log("data.amount: ", data.amount);
        this.getData();
        this.callculateProduct();
        this.closeItem();
      } catch (error) {
        console.log(error);
        alert(error);
      }
    },
    async saveDelete(item) {
      try {
        if (confirm("delete it?")) {
          const { data } = await this.axios.delete(
            "http://localhost:3000/listOrder/" + item
          );
          console.log(data);
          this.getData();
          this.closeItem();
        }
      } catch (error) {
        console(error);
        alert(error);
      }
    },
    getDynamicImage() {
      console.log("API: ", this.apidata);
      for (let i = 0; i < this.apidata.length; i++) {
        const findImg = this.apidata[i];
        console.log("findImg: ", findImg);
        if (findImg.items === "I Phone 15") {
          this.apidata[i].dynamicImageUrl =
            "https://store.storeimages.cdn-apple.com/8756/as-images.apple.com/is/iphone-15-finish-select-202309-6-1inch-black_FMT_WHH?wid=1200&hei=630&fmt=jpeg&qlt=95&.v=1692923776227";
          // return this.apidata[i].dynamicImageUrl;
        } else if (findImg.items === "I Phone 15 ProMax") {
          this.apidata[i].dynamicImageUrl =
            "https://store.storeimages.cdn-apple.com/8756/as-images.apple.com/is/iphone-15-pro-finish-select-202309-6-1inch-whitetitanium?wid=1200&hei=630&fmt=jpeg&qlt=95&.v=1692846367180";
          // return this.apidata[i].dynamicImageUrl;
        } else if (findImg.items === "I phone 15 ProMax") {
          this.apidata[i].dynamicImageUrl =
            "https://store.storeimages.cdn-apple.com/1/as-images.apple.com/is/iphone-15-pro-finish-select-202309-6-7inch-blacktitanium?wid=5120&hei=2880&fmt=p-jpg&qlt=80&.v=VW44dkRidm5wazhwcGxtL0cyaEJ2VTkrNXBUdUJSK1k4NE5seUtJaW80ZEVRNFN1aThHM1R3Z1g3RUVXYlJtU2lCQmV2WTA2cncybDF2YzFnKzI0S3J4M3lYcDIyK01lckZBaW5GTC9DMEQxcjBVRyswWG14bEI4WVZBcUIybEYyQ1lHTzV4YUgyTWtSdk02UmRER0p3PT0=&traceId=1";
          console.log("aaaaaa");
          // return this.apidata[i].dynamicImageUrl;
        }
        // } else if (
        //   findImg.items === "I phone 15 ProMax" &&
        //   findImg.detail.color === "blue"
        // ) {
        //   this.apidata[i].dynamicImageUrl =
        //     "https://store.storeimages.cdn-apple.com/1/as-images.apple.com/is/iphone-15-pro-finish-select-202309-6-7inch-bluetitanium?wid=5120&hei=2880&fmt=p-jpg&qlt=80&.v=VW44dkRidm5wazhwcGxtL0cyaEJ2VTkrNXBUdUJSK1k4NE5seUtJaW80Y0hGc1VYcU5MZG1Wc3p5djdGRkpkOXB3azBNWWRMTTJUR1Y1SkFQMTJmYytRU0p3cnVrZzhmdWQwTDVYRlMxUFpLVUtTU1p5Q3hjSjJnWUpQQWJXd2o0TDRqc1ZQcWdXTk1hOTBSVG5aenpBPT0=&traceId=1";
        // } else if (
        //   findImg.items === "I Phone 15" &&
        //   findImg.detail.color === "Green"
        // ) {
        //   this.apidata[i].dynamicImageUrl =
        //     "https://store.storeimages.cdn-apple.com/1/as-images.apple.com/is/iphone-15-finish-select-202309-6-1inch-green_FMT_WHH?wid=1280&hei=492&fmt=p-jpg&qlt=80&.v=cHJOTXEwTU92OEtKVDV2cVB1R2FTSjlERndlRTljaUdZeHJGM3dlLzR2OEIzenlaemVZcXF4dWN4a1o1bms5UGJWU3RPOURZS0RCaG1weXBRYytNTEZIMVU3blhIMm9GdXVFaFpISW1jUE4vd3djUElYUEl5ak9OVThyMUdieDBBdzM2VnRnZmw5M0I2VVpZMzZLdklnPT0=&traceId=1";
        // }
      }
      return "";
    },
    // async callculateProduct() {
    //   const productsID = this.id; //id product ที่ เลื่อก
    //   const producted = this.editProduct; // product หลังแก้
    //   const amountCurrent = this.postOrder.amount;
    //   const currentValue = this.devalue;
    //   let updatedAmount = 0;

    //   const response = await this.axios.get("http://localhost:3000/product/");
    //   this.apidataProduct = response.data.data;
    //   console.log("ID product: ", productsID); //
    //   console.log("product: ", producted);
    //   console.log("amout current: ", amountCurrent);
    //   console.log("currentValue: ", currentValue);

    //   // try {
    //   //   console.log(" this.apidataProduct: ", this.apidataProduct);
    //   //   for (let i = 0; i < this.apidataProduct.length; i++) {
    //   //     if (this.apidataProduct[i]._id == productsID) {
    //   //       console.log("IDDDDD: ", this.apidataProduct[i]._id == productsID);
    //   //       console.log("PPPPPPPPP: ", this.apidataProduct);
    //   //       if (currentValue) {
    //   //         updatedAmount = this.apidataProduct[i].amount + producted;
    //   //       } else {
    //   //         updatedAmount = this.apidataProduct[i].amount - producted;
    //   //       }
    //   //       await this.axios.put(
    //   //         "http://localhost:3000/product/" + this.apidataProduct[i]._id,
    //   //         { amount: updatedAmount } // ส่งข้อมูลที่ต้องการอัปเดตในรูปแบบของออบเจ็กต์
    //   //       );
    //   //       alert("putttt");
    //   //     } else {
    //   //       console.log("else");
    //   //     }
    //   //   }
    //   //   alert("nol for");
    //   //   // this.getDataProduct();
    //   // } catch (error) {
    //   //   console.error("An error occurred:", error);
    //   // }
    // },
  },
  created() {
    this.getData();
    this.getDynamicImage();
  },
};
</script>

<style></style>
